require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ARCH_DESC_H)) {
    eval 'sub __ARCH_DESC_H () {1;}' unless defined(&__ARCH_DESC_H);
    require 'asm/ldt.ph';
    eval 'sub __FIRST_TSS_ENTRY () {12;}' unless defined(&__FIRST_TSS_ENTRY);
    eval 'sub __FIRST_LDT_ENTRY () {( &__FIRST_TSS_ENTRY+1);}' unless defined(&__FIRST_LDT_ENTRY);
    eval 'sub __TSS {
        my($n) = @_;
	    eval q(((($n)<<2) +  &__FIRST_TSS_ENTRY));
    }' unless defined(&__TSS);
    eval 'sub __LDT {
        my($n) = @_;
	    eval q(((($n)<<2) +  &__FIRST_LDT_ENTRY));
    }' unless defined(&__LDT);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub idt_descr () {(*( &idt - 2));}' unless defined(&idt_descr);
	eval 'sub gdt_descr () {(*( &gdt - 2));}' unless defined(&gdt_descr);
	eval 'sub load_TR {
	    my($n) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&load_TR);
	eval 'sub __load_LDT {
	    my($n) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__load_LDT);
	eval 'sub clear_LDT {
	    my($void) = @_;
    	    eval q({ \'int\'  &cpu =  &smp_processor_id();  &set_ldt_desc( &cpu,  $default_ldt[0], 5);  &__load_LDT( &cpu); });
	}' unless defined(&clear_LDT);
    }
}
1;
