require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_FIXMAP_H)) {
    eval 'sub _ASM_FIXMAP_H () {1;}' unless defined(&_ASM_FIXMAP_H);
    require 'linux/config.ph';
    require 'linux/kernel.ph';
    require 'asm/acpi.ph';
    require 'asm/apicdef.ph';
    require 'asm/page.ph';
    if(defined(&CONFIG_HIGHMEM)) {
	require 'linux/threads.ph';
	require 'asm/kmap_types.ph';
    }
    eval("sub __end_of_permanent_fixed_addresses () { 0; }") unless defined(&__end_of_permanent_fixed_addresses);
    eval("sub NR_FIX_BTMAPS () { 16; }") unless defined(&NR_FIX_BTMAPS);
    eval("sub FIX_BTMAP_END () { __end_of_permanent_fixed_addresses; }") unless defined(&FIX_BTMAP_END);
    eval("sub FIX_BTMAP_BEGIN () { FIX_BTMAP_END+NR_FIX_BTMAPS-1; }") unless defined(&FIX_BTMAP_BEGIN);
    eval("sub __end_of_fixed_addresses () { 1; }") unless defined(&__end_of_fixed_addresses);
    eval 'sub set_fixmap {
        my($idx, $phys) = @_;
	    eval q( &__set_fixmap($idx, $phys,  &PAGE_KERNEL));
    }' unless defined(&set_fixmap);
    eval 'sub set_fixmap_nocache {
        my($idx, $phys) = @_;
	    eval q( &__set_fixmap($idx, $phys,  &PAGE_KERNEL_NOCACHE));
    }' unless defined(&set_fixmap_nocache);
    eval 'sub FIXADDR_TOP () {(0xffffe000);}' unless defined(&FIXADDR_TOP);
    eval 'sub __FIXADDR_SIZE () {( &__end_of_permanent_fixed_addresses <<  &PAGE_SHIFT);}' unless defined(&__FIXADDR_SIZE);
    eval 'sub FIXADDR_START () {( &FIXADDR_TOP -  &__FIXADDR_SIZE);}' unless defined(&FIXADDR_START);
    eval 'sub __fix_to_virt {
        my($x) = @_;
	    eval q(( &FIXADDR_TOP - (($x) <<  &PAGE_SHIFT)));
    }' unless defined(&__fix_to_virt);
}
1;
