require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASMi386_IDE_H)) {
    eval 'sub __ASMi386_IDE_H () {1;}' unless defined(&__ASMi386_IDE_H);
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	unless(defined(&MAX_HWIFS)) {
	    if(defined(&CONFIG_BLK_DEV_IDEPCI)) {
		eval 'sub MAX_HWIFS () {10;}' unless defined(&MAX_HWIFS);
	    } else {
		eval 'sub MAX_HWIFS () {6;}' unless defined(&MAX_HWIFS);
	    }
	}
	eval 'sub ide_default_irq {
	    my($base) = @_;
    	    eval q({  &switch ($base) {  &case 0x1f0: 14;  &case 0x170: 15;  &case 0x1e8: 11;  &case 0x168: 10;  &case 0x1e0: 8;  &case 0x160: 12;  &default: 0; } });
	}' unless defined(&ide_default_irq);
	eval 'sub ide_default_io_base {
	    my($index) = @_;
    	    eval q({  &switch ($index) {  &case 0: 0x1f0;  &case 1: 0x170;  &case 2: 0x1e8;  &case 3: 0x168;  &case 4: 0x1e0;  &case 5: 0x160;  &default: 0; } });
	}' unless defined(&ide_default_io_base);
	eval 'sub ide_init_hwif_ports {
	    my($hw,$data_port,$ctrl_port,$irq) = @_;
    	    eval q({  &ide_ioreg_t  &reg = $data_port; \'int\'  &i;  &for ( &i =  &IDE_DATA_OFFSET;  &i <=  &IDE_STATUS_OFFSET;  &i++) {  ($hw->{io_ports[&i]}) =  &reg;  &reg += 1; }  &if ($ctrl_port) {  ($hw->{io_ports[&IDE_CONTROL_OFFSET]}) = $ctrl_port; }  &else {  ($hw->{io_ports[&IDE_CONTROL_OFFSET]}) =  ($hw->{io_ports[&IDE_DATA_OFFSET]}) + 0x206; }  &if ($irq !=  &NULL) *$irq = 0;  ($hw->{io_ports[&IDE_IRQ_OFFSET]}) = 0; });
	}' unless defined(&ide_init_hwif_ports);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub ide_init_default_hwifs {
	    my($void) = @_;
    	    eval q({ });
	}' unless defined(&ide_init_default_hwifs);
	require 'asm-generic/ide_iops.ph';
    }
}
1;
