require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__I386_MMU_CONTEXT_H)) {
    eval 'sub __I386_MMU_CONTEXT_H () {1;}' unless defined(&__I386_MMU_CONTEXT_H);
    require 'linux/config.ph';
    require 'asm/desc.ph';
    require 'asm/atomic.ph';
    require 'asm/pgalloc.ph';
    eval 'sub destroy_context {
        my($mm) = @_;
	    eval q( &do { }  &while(0));
    }' unless defined(&destroy_context);
    eval 'sub init_new_context {
        my($tsk,$mm) = @_;
	    eval q(0);
    }' unless defined(&init_new_context);
    if(defined(&CONFIG_SMP)) {
	eval 'sub enter_lazy_tlb {
	    my($mm,$tsk,$cpu) = @_;
    	    eval q({  &if( ($cpu_tlbstate[$cpu]->{state}) ==  &TLBSTATE_OK)  ($cpu_tlbstate[$cpu]->{state}) =  &TLBSTATE_LAZY; });
	}' unless defined(&enter_lazy_tlb);
    } else {
	eval 'sub enter_lazy_tlb {
	    my($mm,$tsk,$cpu) = @_;
    	    eval q({ });
	}' unless defined(&enter_lazy_tlb);
    }
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub switch_mm {
        my($prev,$next,$tsk,$cpu) = @_;
	    eval q({  &if ($prev != $next) {  &clear_bit($cpu,  ($prev->{cpu_vm_mask}));  &if ( ($prev->{context}->{segments}) !=  ($next->{context}->{segments}))  &load_LDT($next);  &set_bit($cpu,  ($next->{cpu_vm_mask}));  &set_bit($cpu,  ($next->{context}->{cpuvalid}));  &load_cr3( ($next->{pgd})); } });
    }' unless defined(&switch_mm);
    eval 'sub activate_mm {
        my($prev, $next) = @_;
	    eval q( &switch_mm(($prev),($next), &NULL, &smp_processor_id()));
    }' unless defined(&activate_mm);
}
1;
