require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SMP_H)) {
    eval 'sub __ASM_SMP_H () {1;}' unless defined(&__ASM_SMP_H);
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/config.ph';
	require 'linux/threads.ph';
	require 'linux/ptrace.ph';
    }
    if(defined(&CONFIG_X86_LOCAL_APIC)) {
	unless(defined(&__ASSEMBLY__)) {
	    require 'asm/fixmap.ph';
	    require 'asm/bitops.ph';
	    require 'asm/mpspec.ph';
	    if(defined(&CONFIG_X86_IO_APIC)) {
		require 'asm/io_apic.ph';
	    }
	    require 'asm/apic.ph';
	}
    }
    if(defined(&CONFIG_SMP)) {
	unless(defined(&__ASSEMBLY__)) {
	    eval 'sub cpu_number_map {
	        my($cpu) = @_;
    		eval q({ $cpu; });
	    }' unless defined(&cpu_number_map);
	    eval 'sub MAX_APICID () {256;}' unless defined(&MAX_APICID);
	    eval 'sub smp_processor_id () {
	        eval q(( ($current->{processor})));
	    }' unless defined(&smp_processor_id);
	    eval 'sub hard_smp_processor_id {
	        my($void) = @_;
    		eval q({  &GET_APIC_ID(*( &APIC_BASE+ &APIC_ID)); });
	    }' unless defined(&hard_smp_processor_id);
	    eval 'sub logical_smp_processor_id {
	        my($void) = @_;
    		eval q({  &GET_APIC_LOGICAL_ID(*( &APIC_BASE+ &APIC_LDR)); });
	    }' unless defined(&logical_smp_processor_id);
	}
	eval 'sub NO_PROC_ID () {0xff;}' unless defined(&NO_PROC_ID);
	eval 'sub PROC_CHANGE_PENALTY () {15;}' unless defined(&PROC_CHANGE_PENALTY);
    }
}
1;
