require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_HIGHMEM_H)) {
    eval 'sub _ASM_HIGHMEM_H () {1;}' unless defined(&_ASM_HIGHMEM_H);
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	require 'linux/init.ph';
	require 'linux/interrupt.ph';
	require 'asm/kmap_types.ph';
	require 'asm/pgtable.ph';
	if(defined(&CONFIG_DEBUG_HIGHMEM)) {
	    eval 'sub HIGHMEM_DEBUG () {1;}' unless defined(&HIGHMEM_DEBUG);
	} else {
	    eval 'sub HIGHMEM_DEBUG () {0;}' unless defined(&HIGHMEM_DEBUG);
	}
	eval 'sub PKMAP_BASE () {(0xfe000000);}' unless defined(&PKMAP_BASE);
	if(defined(&CONFIG_X86_PAE)) {
	    eval 'sub LAST_PKMAP () {512;}' unless defined(&LAST_PKMAP);
	} else {
	    eval 'sub LAST_PKMAP () {1024;}' unless defined(&LAST_PKMAP);
	}
	eval 'sub LAST_PKMAP_MASK () {( &LAST_PKMAP-1);}' unless defined(&LAST_PKMAP_MASK);
	eval 'sub PKMAP_NR {
	    my($virt) = @_;
    	    eval q((($virt- &PKMAP_BASE) >>  &PAGE_SHIFT));
	}' unless defined(&PKMAP_NR);
	eval 'sub PKMAP_ADDR {
	    my($nr) = @_;
    	    eval q(( &PKMAP_BASE + (($nr) <<  &PAGE_SHIFT)));
	}' unless defined(&PKMAP_ADDR);
	eval 'sub kmap {
	    my($page) = @_;
    	    eval q( &__kmap($page, 0));
	}' unless defined(&kmap);
	eval 'sub kmap_nonblock {
	    my($page) = @_;
    	    eval q( &__kmap($page, 1));
	}' unless defined(&kmap_nonblock);
	eval 'sub void {
	    eval q(* &__kmap(\'struct page\' * &page, \'int\'  &nonblocking) {  &if ( &in_interrupt())  &out_of_line_bug();  &if ( &page <  &highmem_start_page)  &page_address( &page);  &kmap_high( &page,  &nonblocking); });
	}' unless defined(&void);
	eval 'sub kunmap {
	    my($page) = @_;
    	    eval q({  &if ( &in_interrupt())  &out_of_line_bug();  &if ($page <  &highmem_start_page) ;  &kunmap_high($page); });
	}' unless defined(&kunmap);
	if((defined(&HIGHMEM_DEBUG) ? &HIGHMEM_DEBUG : 0)) {
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub kunmap_atomic {
	    my($kvaddr,$type) = @_;
    	    eval q({ });
	}' unless defined(&kunmap_atomic);
    }
}
1;
