require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__i386_PCI_H)) {
    eval 'sub __i386_PCI_H () {1;}' unless defined(&__i386_PCI_H);
    require 'linux/config.ph';
    if(defined(&__KERNEL__)) {
	if(defined(&CONFIG_PCI)) {
	} else {
	    eval 'sub pcibios_assign_all_busses () {
	        eval q(0);
	    }' unless defined(&pcibios_assign_all_busses);
	}
	eval 'sub PCIBIOS_MIN_IO () {0x1000;}' unless defined(&PCIBIOS_MIN_IO);
	eval 'sub PCIBIOS_MIN_MEM () {( &pci_mem_start);}' unless defined(&PCIBIOS_MIN_MEM);
	require 'linux/types.ph';
	require 'linux/slab.ph';
	require 'asm/scatterlist.ph';
	require 'linux/string.ph';
	require 'asm/io.ph';
	eval 'sub PCI_DMA_BUS_IS_PHYS () {(1);}' unless defined(&PCI_DMA_BUS_IS_PHYS);
	eval 'sub pci_unmap_page {
	    my($hwdev,$dma_address,$size,$direction) = @_;
    	    eval q({  &if ($direction ==  &PCI_DMA_NONE)  &out_of_line_bug(); }  &define  &DECLARE_PCI_UNMAP_ADDR( &ADDR_NAME)  &define  &DECLARE_PCI_UNMAP_LEN( &LEN_NAME)  &define  &pci_unmap_addr( &PTR,  &ADDR_NAME) (0)  &define  &pci_unmap_addr_set( &PTR,  &ADDR_NAME,  &VAL)  &do { }  &while (0)  &define  &pci_unmap_len( &PTR,  &LEN_NAME) (0)  &define  &pci_unmap_len_set( &PTR,  &LEN_NAME,  &VAL)  &do { }  &while (0) \'int\'  &pci_map_sg(\'struct pci_dev\' *$hwdev, \'struct scatterlist\' * &sg, \'int\'  &nents, \'int\' $direction) { \'int\'  &i;  &if ($direction ==  &PCI_DMA_NONE)  &out_of_line_bug();  &for ( &i = 0;  &i <  &nents;  &i++ ) {  &if ( ($sg[&i]->{address})  &&  ($sg[&i]->{page}))  &out_of_line_bug();  &else  &if (! ($sg[&i]->{address})  && ! ($sg[&i]->{page}))  &out_of_line_bug();  &if ( ($sg[&i]->{address}))  ($sg[&i]->{dma_address}) =  &virt_to_bus( ($sg[&i]->{address}));  &else  ($sg[&i]->{dma_address}) =  &page_to_bus( ($sg[&i]->{page})) +  ($sg[&i]->{offset}); }  &flush_write_buffers();  &nents; });
	}' unless defined(&pci_unmap_page);
	eval 'sub pci_dac_dma_supported {
	    my($pci_dev, $mask) = @_;
    	    eval q((1));
	}' unless defined(&pci_dac_dma_supported);
	eval 'sub pci_dac_page_to_dma {
	    my($pdev,$page,$offset,$direction) = @_;
    	    eval q({ (( &dma64_addr_t)  &page_to_bus($page) + ( &dma64_addr_t) $offset); });
	}' unless defined(&pci_dac_page_to_dma);
	eval 'sub pci_dac_dma_to_page {
	    my($pdev,$dma_addr) = @_;
    	    eval q({ my $poff = ($dma_addr >>  &PAGE_SHIFT);  &mem_map +  $poff; });
	}' unless defined(&pci_dac_dma_to_page);
	eval 'sub pci_dac_dma_to_offset {
	    my($pdev,$dma_addr) = @_;
    	    eval q({ ($dma_addr & ~ &PAGE_MASK); });
	}' unless defined(&pci_dac_dma_to_offset);
	eval 'sub pci_dac_dma_sync_single {
	    my($pdev,$dma_addr,$len,$direction) = @_;
    	    eval q({  &flush_write_buffers(); });
	}' unless defined(&pci_dac_dma_sync_single);
	eval 'sub sg_dma_address {
	    my($sg) = @_;
    	    eval q((($sg)-> &dma_address));
	}' unless defined(&sg_dma_address);
	eval 'sub sg_dma_len {
	    my($sg) = @_;
    	    eval q((($sg)-> &length));
	}' unless defined(&sg_dma_len);
	eval 'sub HAVE_PCI_MMAP () {1;}' unless defined(&HAVE_PCI_MMAP);
    }
}
1;
