require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_I386_PGTABLE_3LEVEL_H)) {
    eval 'sub _I386_PGTABLE_3LEVEL_H () {1;}' unless defined(&_I386_PGTABLE_3LEVEL_H);
    eval 'sub PGDIR_SHIFT () {30;}' unless defined(&PGDIR_SHIFT);
    eval 'sub PTRS_PER_PGD () {4;}' unless defined(&PTRS_PER_PGD);
    eval 'sub PMD_SHIFT () {21;}' unless defined(&PMD_SHIFT);
    eval 'sub PTRS_PER_PMD () {512;}' unless defined(&PTRS_PER_PMD);
    eval 'sub PTRS_PER_PTE () {512;}' unless defined(&PTRS_PER_PTE);
    eval 'sub pte_ERROR {
        my($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pte %p(%08lx%08lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e), ($e). &pte_high, ($e). &pte_low));
    }' unless defined(&pte_ERROR);
    eval 'sub pmd_ERROR {
        my($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pmd %p(%016Lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e),  &pmd_val($e)));
    }' unless defined(&pmd_ERROR);
    eval 'sub pgd_ERROR {
        my($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pgd %p(%016Lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e),  &pgd_val($e)));
    }' unless defined(&pgd_ERROR);
    eval 'sub pgd_present {
        my($pgd) = @_;
	    eval q({ 1; }  &void  &set_pte( &pte_t * &ptep,  &pte_t  &pte) {  ($ptep->{pte_high}) =  ($pte->{pte_high});  &smp_wmb();  ($ptep->{pte_low}) =  ($pte->{pte_low}); });
    }' unless defined(&pgd_present);
    eval 'sub set_pmd {
        my($pmdptr,$pmdval) = @_;
	    eval q( &set_64bit(($pmdptr), &pmd_val($pmdval)));
    }' unless defined(&set_pmd);
    eval 'sub set_pgd {
        my($pgdptr,$pgdval) = @_;
	    eval q( &set_64bit(($pgdptr), &pgd_val($pgdval)));
    }' unless defined(&set_pgd);
    eval 'sub set_pte_atomic {
        my($pteptr,$pteval) = @_;
	    eval q( &set_64bit(($pteptr), &pte_val($pteval)));
    }' unless defined(&set_pte_atomic);
    eval 'sub pgd_page {
        my($pgd) = @_;
	    eval q((  &__va( &pgd_val($pgd) &  &PAGE_MASK)));
    }' unless defined(&pgd_page);
    eval 'sub pmd_offset {
        my($dir, $address) = @_;
	    eval q((( &pmd_t *)  &pgd_page(*($dir)) +  &__pmd_offset($address)));
    }' unless defined(&pmd_offset);
    eval 'sub ptep_get_and_clear {
        my($ptep) = @_;
	    eval q({  &pte_t  &res;  ($res->{pte_low}) =  &xchg( ($ptep->{pte_low}), 0);  ($res->{pte_high}) =  ($ptep->{pte_high});  ($ptep->{pte_high}) = 0;  &res; });
    }' unless defined(&ptep_get_and_clear);
    eval 'sub pte_same {
        my($a,$b) = @_;
	    eval q({  ($a->{pte_low}) ==  ($b->{pte_low})  &&  ($a->{pte_high}) ==  ($b->{pte_high}); });
    }' unless defined(&pte_same);
    eval 'sub pte_page {
        my($x) = @_;
	    eval q(( &mem_map+((($x). &pte_low >>  &PAGE_SHIFT) | (($x). &pte_high << (32-  &PAGE_SHIFT)))));
    }' unless defined(&pte_page);
    eval 'sub pte_none {
        my($x) = @_;
	    eval q((!($x). &pte_low  && !($x). &pte_high));
    }' unless defined(&pte_none);
    eval 'sub __mk_pte {
        my($page_nr,$pgprot) = @_;
	    eval q({  &pte_t  &pte;  ($pte->{pte_high}) = $page_nr >> (32-  &PAGE_SHIFT);  ($pte->{pte_low}) = ($page_nr <<  &PAGE_SHIFT) |  &pgprot_val($pgprot);  &pte; });
    }' unless defined(&__mk_pte);
}
1;
