require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SMPBOOT_H)) {
    eval 'sub __ASM_SMPBOOT_H () {1;}' unless defined(&__ASM_SMPBOOT_H);
    eval("sub CLUSTERED_APIC_NONE () { 0; }") unless defined(&CLUSTERED_APIC_NONE);
    eval("sub CLUSTERED_APIC_XAPIC () { 1; }") unless defined(&CLUSTERED_APIC_XAPIC);
    eval("sub CLUSTERED_APIC_NUMAQ () { 2; }") unless defined(&CLUSTERED_APIC_NUMAQ);
    if(defined(&CONFIG_X86_CLUSTERED_APIC)) {
	eval 'sub detect_clustered_apic {
	    my($oem,$prod) = @_;
    	    eval q({  &if (! &strncmp($oem, \\"IBM ENSW\\", 8)  && ! &strncmp($prod, \\"VIGIL SMP\\", 9)){  &clustered_apic_mode =  &CLUSTERED_APIC_XAPIC;  &apic_broadcast_id =  &APIC_BROADCAST_ID_XAPIC;  &int_dest_addr_mode =  &APIC_DEST_PHYSICAL;  &int_delivery_mode =  &dest_Fixed;  &esr_disable = 1;  &cyclone_setup(0); }  &else  &if (! &strncmp($oem, \\"IBM\\", 3)  && (! &strncmp($prod, \\"SERVIGIL\\", 8) || ! &strncmp($prod, \\"EXA\\", 3) || ! &strncmp($prod, \\"RUTHLESS\\", 8))){  &clustered_apic_mode =  &CLUSTERED_APIC_XAPIC;  &apic_broadcast_id =  &APIC_BROADCAST_ID_XAPIC;  &int_dest_addr_mode =  &APIC_DEST_PHYSICAL;  &int_delivery_mode =  &dest_Fixed;  &esr_disable = 1;  &cyclone_setup(0); }  &else  &if (! &strncmp($oem, \\"IBM NUMA\\", 8)){  &clustered_apic_mode =  &CLUSTERED_APIC_NUMAQ;  &apic_broadcast_id =  &APIC_BROADCAST_ID_APIC;  &int_dest_addr_mode =  &APIC_DEST_LOGICAL;  &int_delivery_mode =  &dest_LowestPrio;  &esr_disable = 1; } });
	}' unless defined(&detect_clustered_apic);
	eval 'sub INT_DEST_ADDR_MODE () {( &int_dest_addr_mode);}' unless defined(&INT_DEST_ADDR_MODE);
	eval 'sub INT_DELIVERY_MODE () {( &int_delivery_mode);}' unless defined(&INT_DELIVERY_MODE);
    } else {
	eval 'sub apic_broadcast_id () {( &APIC_BROADCAST_ID_APIC);}' unless defined(&apic_broadcast_id);
	eval 'sub clustered_apic_mode () {( &CLUSTERED_APIC_NONE);}' unless defined(&clustered_apic_mode);
	eval 'sub esr_disable () {(0);}' unless defined(&esr_disable);
	eval 'sub detect_clustered_apic {
	    my($x,$y) = @_;
    	    eval q();
	}' unless defined(&detect_clustered_apic);
	eval 'sub INT_DEST_ADDR_MODE () {( &APIC_DEST_LOGICAL);}' unless defined(&INT_DEST_ADDR_MODE);
	eval 'sub INT_DELIVERY_MODE () {( &dest_LowestPrio);}' unless defined(&INT_DELIVERY_MODE);
    }
    eval 'sub BAD_APICID () {0xff;}' unless defined(&BAD_APICID);
    eval 'sub TRAMPOLINE_LOW () { &phys_to_virt(( &clustered_apic_mode ==  &CLUSTERED_APIC_NUMAQ)?0x8:0x467);}' unless defined(&TRAMPOLINE_LOW);
    eval 'sub TRAMPOLINE_HIGH () { &phys_to_virt(( &clustered_apic_mode ==  &CLUSTERED_APIC_NUMAQ)?0xa:0x469);}' unless defined(&TRAMPOLINE_HIGH);
    eval 'sub boot_cpu_apicid () {(( &clustered_apic_mode ==  &CLUSTERED_APIC_NUMAQ)? &boot_cpu_logical_apicid: &boot_cpu_physical_apicid);}' unless defined(&boot_cpu_apicid);
    eval 'sub apicid_to_phys_cpu_present {
        my($apicid) = @_;
	    eval q({  &if( &clustered_apic_mode) 1 << ((($apicid >> 4) << 2) + ($apicid & 0x3)); 1 << $apicid; });
    }' unless defined(&apicid_to_phys_cpu_present);
    eval 'sub physical_to_logical_apicid {
        my($phys_apic) = @_;
	    eval q(( (1 << ($phys_apic & 0x3)) | ($phys_apic & 0xf0) ));
    }' unless defined(&physical_to_logical_apicid);
    eval 'sub logical_apicid_to_cpu {
        my($apicid) = @_;
	    eval q( $logical_apicid_2_cpu[$apicid]);
    }' unless defined(&logical_apicid_to_cpu);
    eval 'sub cpu_to_logical_apicid {
        my($cpu) = @_;
	    eval q( $cpu_2_logical_apicid[$cpu]);
    }' unless defined(&cpu_to_logical_apicid);
    eval 'sub physical_apicid_to_cpu {
        my($apicid) = @_;
	    eval q( $physical_apicid_2_cpu[$apicid]);
    }' unless defined(&physical_apicid_to_cpu);
    eval 'sub cpu_to_physical_apicid {
        my($cpu) = @_;
	    eval q( $cpu_2_physical_apicid[$cpu]);
    }' unless defined(&cpu_to_physical_apicid);
    if(defined(&CONFIG_MULTIQUAD)) {
	eval 'sub boot_apicid_to_cpu {
	    my($apicid) = @_;
    	    eval q( $logical_apicid_2_cpu[$apicid]);
	}' unless defined(&boot_apicid_to_cpu);
	eval 'sub cpu_to_boot_apicid {
	    my($cpu) = @_;
    	    eval q( $cpu_2_logical_apicid[$cpu]);
	}' unless defined(&cpu_to_boot_apicid);
    } else {
	eval 'sub boot_apicid_to_cpu {
	    my($apicid) = @_;
    	    eval q( $physical_apicid_2_cpu[$apicid]);
	}' unless defined(&boot_apicid_to_cpu);
	eval 'sub cpu_to_boot_apicid {
	    my($cpu) = @_;
    	    eval q( $cpu_2_physical_apicid[$cpu]);
	}' unless defined(&cpu_to_boot_apicid);
    }
    if(defined(&CONFIG_X86_CLUSTERED_APIC)) {
	eval 'sub target_cpus {
	    my($void) = @_;
    	    eval q({ \'int\'  &cpu;  &switch( &clustered_apic_mode){  &case  &CLUSTERED_APIC_NUMAQ:  &APIC_BROADCAST_ID_APIC;  &case  &CLUSTERED_APIC_XAPIC:  &cpu = ( &cpu+1)% &smp_num_cpus;  &cpu_to_physical_apicid( &cpu);  &default: }  &cpu_online_map; });
	}' unless defined(&target_cpus);
    } else {
	eval 'sub target_cpus () {
	    eval q(( &cpu_online_map));
	}' unless defined(&target_cpus);
    }
}
1;
