require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SMPLOCK_H)) {
    eval 'sub __ASM_SMPLOCK_H () {1;}' unless defined(&__ASM_SMPLOCK_H);
    require 'linux/interrupt.ph';
    require 'linux/spinlock.ph';
    require 'linux/sched.ph';
    require 'asm/current.ph';
    eval 'sub kernel_flag () { ($kernel_flag_cacheline->{lock});}' unless defined(&kernel_flag);
    eval 'sub kernel_locked () {
        eval q( &spin_is_locked( &kernel_flag));
    }' unless defined(&kernel_locked);
    eval 'sub release_kernel_lock {
        my($task, $cpu) = @_;
	    eval q( &do {  &if ( ($task->{lock_depth}) >= 0)  &spin_unlock( &kernel_flag);  &release_irqlock($cpu);  &__sti(); }  &while (0));
    }' unless defined(&release_kernel_lock);
    eval 'sub reacquire_kernel_lock {
        my($task) = @_;
	    eval q( &do {  &if ( ($task->{lock_depth}) >= 0)  &spin_lock( &kernel_flag); }  &while (0));
    }' unless defined(&reacquire_kernel_lock);
    if(1) {
    } else {
    }
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub unlock_kernel {
        my($void) = @_;
	    eval q({  &if ( ($current->{lock_depth}) < 0)  &out_of_line_bug(); });
    }' unless defined(&unlock_kernel);
}
1;
