require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&AUTOCONF_INCLUDED)) {
    sub AUTOCONF_INCLUDED () {	1;}
}
unless(defined(&CONFIG_X86)) {
    sub CONFIG_X86 () {	1;}
}
undef(&CONFIG_SBUS) if defined(&CONFIG_SBUS);
unless(defined(&CONFIG_UID16)) {
    sub CONFIG_UID16 () {	1;}
}
undef(&CONFIG_EXPERIMENTAL) if defined(&CONFIG_EXPERIMENTAL);
unless(defined(&CONFIG_MODULES)) {
    sub CONFIG_MODULES () {	1;}
}
unless(defined(&CONFIG_MODVERSIONS)) {
    sub CONFIG_MODVERSIONS () {	1;}
}
unless(defined(&CONFIG_KMOD)) {
    sub CONFIG_KMOD () {	1;}
}
undef(&CONFIG_M386) if defined(&CONFIG_M386);
undef(&CONFIG_M486) if defined(&CONFIG_M486);
undef(&CONFIG_M586) if defined(&CONFIG_M586);
undef(&CONFIG_M586TSC) if defined(&CONFIG_M586TSC);
undef(&CONFIG_M586MMX) if defined(&CONFIG_M586MMX);
undef(&CONFIG_M686) if defined(&CONFIG_M686);
unless(defined(&CONFIG_MPENTIUMIII)) {
    sub CONFIG_MPENTIUMIII () {	1;}
}
undef(&CONFIG_MPENTIUM4) if defined(&CONFIG_MPENTIUM4);
undef(&CONFIG_MK6) if defined(&CONFIG_MK6);
undef(&CONFIG_MK7) if defined(&CONFIG_MK7);
undef(&CONFIG_MK8) if defined(&CONFIG_MK8);
undef(&CONFIG_MELAN) if defined(&CONFIG_MELAN);
undef(&CONFIG_MCRUSOE) if defined(&CONFIG_MCRUSOE);
undef(&CONFIG_MWINCHIPC6) if defined(&CONFIG_MWINCHIPC6);
undef(&CONFIG_MWINCHIP2) if defined(&CONFIG_MWINCHIP2);
undef(&CONFIG_MWINCHIP3D) if defined(&CONFIG_MWINCHIP3D);
undef(&CONFIG_MCYRIXIII) if defined(&CONFIG_MCYRIXIII);
undef(&CONFIG_MVIAC3_2) if defined(&CONFIG_MVIAC3_2);
unless(defined(&CONFIG_X86_WP_WORKS_OK)) {
    sub CONFIG_X86_WP_WORKS_OK () {	1;}
}
unless(defined(&CONFIG_X86_INVLPG)) {
    sub CONFIG_X86_INVLPG () {	1;}
}
unless(defined(&CONFIG_X86_CMPXCHG)) {
    sub CONFIG_X86_CMPXCHG () {	1;}
}
unless(defined(&CONFIG_X86_XADD)) {
    sub CONFIG_X86_XADD () {	1;}
}
unless(defined(&CONFIG_X86_BSWAP)) {
    sub CONFIG_X86_BSWAP () {	1;}
}
unless(defined(&CONFIG_X86_POPAD_OK)) {
    sub CONFIG_X86_POPAD_OK () {	1;}
}
undef(&CONFIG_RWSEM_GENERIC_SPINLOCK) if defined(&CONFIG_RWSEM_GENERIC_SPINLOCK);
unless(defined(&CONFIG_RWSEM_XCHGADD_ALGORITHM)) {
    sub CONFIG_RWSEM_XCHGADD_ALGORITHM () {	1;}
}
unless(defined(&CONFIG_X86_L1_CACHE_SHIFT)) {
    sub CONFIG_X86_L1_CACHE_SHIFT () {	(5);}
}
unless(defined(&CONFIG_X86_HAS_TSC)) {
    sub CONFIG_X86_HAS_TSC () {	1;}
}
unless(defined(&CONFIG_X86_GOOD_APIC)) {
    sub CONFIG_X86_GOOD_APIC () {	1;}
}
unless(defined(&CONFIG_X86_PGE)) {
    sub CONFIG_X86_PGE () {	1;}
}
unless(defined(&CONFIG_X86_USE_PPRO_CHECKSUM)) {
    sub CONFIG_X86_USE_PPRO_CHECKSUM () {	1;}
}
unless(defined(&CONFIG_X86_F00F_WORKS_OK)) {
    sub CONFIG_X86_F00F_WORKS_OK () {	1;}
}
unless(defined(&CONFIG_X86_MCE)) {
    sub CONFIG_X86_MCE () {	1;}
}
undef(&CONFIG_TOSHIBA) if defined(&CONFIG_TOSHIBA);
undef(&CONFIG_I8K) if defined(&CONFIG_I8K);
undef(&CONFIG_MICROCODE) if defined(&CONFIG_MICROCODE);
undef(&CONFIG_X86_MSR) if defined(&CONFIG_X86_MSR);
undef(&CONFIG_X86_CPUID) if defined(&CONFIG_X86_CPUID);
unless(defined(&CONFIG_NOHIGHMEM)) {
    sub CONFIG_NOHIGHMEM () {	1;}
}
undef(&CONFIG_HIGHMEM4G) if defined(&CONFIG_HIGHMEM4G);
undef(&CONFIG_HIGHMEM64G) if defined(&CONFIG_HIGHMEM64G);
undef(&CONFIG_HIGHMEM) if defined(&CONFIG_HIGHMEM);
undef(&CONFIG_MATH_EMULATION) if defined(&CONFIG_MATH_EMULATION);
undef(&CONFIG_MTRR) if defined(&CONFIG_MTRR);
unless(defined(&CONFIG_SMP)) {
    sub CONFIG_SMP () {	1;}
}
undef(&CONFIG_X86_NUMA) if defined(&CONFIG_X86_NUMA);
undef(&CONFIG_X86_TSC_DISABLE) if defined(&CONFIG_X86_TSC_DISABLE);
unless(defined(&CONFIG_X86_TSC)) {
    sub CONFIG_X86_TSC () {	1;}
}
unless(defined(&CONFIG_HAVE_DEC_LOCK)) {
    sub CONFIG_HAVE_DEC_LOCK () {	1;}
}
unless(defined(&CONFIG_NET)) {
    sub CONFIG_NET () {	1;}
}
unless(defined(&CONFIG_X86_IO_APIC)) {
    sub CONFIG_X86_IO_APIC () {	1;}
}
unless(defined(&CONFIG_X86_LOCAL_APIC)) {
    sub CONFIG_X86_LOCAL_APIC () {	1;}
}
unless(defined(&CONFIG_PCI)) {
    sub CONFIG_PCI () {	1;}
}
undef(&CONFIG_PCI_GOBIOS) if defined(&CONFIG_PCI_GOBIOS);
undef(&CONFIG_PCI_GODIRECT) if defined(&CONFIG_PCI_GODIRECT);
unless(defined(&CONFIG_PCI_GOANY)) {
    sub CONFIG_PCI_GOANY () {	1;}
}
unless(defined(&CONFIG_PCI_BIOS)) {
    sub CONFIG_PCI_BIOS () {	1;}
}
unless(defined(&CONFIG_PCI_DIRECT)) {
    sub CONFIG_PCI_DIRECT () {	1;}
}
unless(defined(&CONFIG_ISA)) {
    sub CONFIG_ISA () {	1;}
}
unless(defined(&CONFIG_PCI_NAMES)) {
    sub CONFIG_PCI_NAMES () {	1;}
}
undef(&CONFIG_EISA) if defined(&CONFIG_EISA);
undef(&CONFIG_MCA) if defined(&CONFIG_MCA);
unless(defined(&CONFIG_HOTPLUG)) {
    sub CONFIG_HOTPLUG () {	1;}
}
unless(defined(&CONFIG_PCMCIA)) {
    sub CONFIG_PCMCIA () {	1;}
}
unless(defined(&CONFIG_CARDBUS)) {
    sub CONFIG_CARDBUS () {	1;}
}
undef(&CONFIG_TCIC) if defined(&CONFIG_TCIC);
undef(&CONFIG_I82092) if defined(&CONFIG_I82092);
undef(&CONFIG_I82365) if defined(&CONFIG_I82365);
undef(&CONFIG_HOTPLUG_PCI) if defined(&CONFIG_HOTPLUG_PCI);
undef(&CONFIG_HOTPLUG_PCI_COMPAQ) if defined(&CONFIG_HOTPLUG_PCI_COMPAQ);
undef(&CONFIG_HOTPLUG_PCI_COMPAQ_NVRAM) if defined(&CONFIG_HOTPLUG_PCI_COMPAQ_NVRAM);
undef(&CONFIG_HOTPLUG_PCI_IBM) if defined(&CONFIG_HOTPLUG_PCI_IBM);
unless(defined(&CONFIG_SYSVIPC)) {
    sub CONFIG_SYSVIPC () {	1;}
}
undef(&CONFIG_BSD_PROCESS_ACCT) if defined(&CONFIG_BSD_PROCESS_ACCT);
unless(defined(&CONFIG_SYSCTL)) {
    sub CONFIG_SYSCTL () {	1;}
}
unless(defined(&CONFIG_KCORE_ELF)) {
    sub CONFIG_KCORE_ELF () {	1;}
}
undef(&CONFIG_KCORE_AOUT) if defined(&CONFIG_KCORE_AOUT);
unless(defined(&CONFIG_BINFMT_AOUT)) {
    sub CONFIG_BINFMT_AOUT () {	1;}
}
unless(defined(&CONFIG_BINFMT_ELF)) {
    sub CONFIG_BINFMT_ELF () {	1;}
}
unless(defined(&CONFIG_BINFMT_MISC)) {
    sub CONFIG_BINFMT_MISC () {	1;}
}
unless(defined(&CONFIG_PM)) {
    sub CONFIG_PM () {	1;}
}
undef(&CONFIG_APM) if defined(&CONFIG_APM);
undef(&CONFIG_ACPI) if defined(&CONFIG_ACPI);
undef(&CONFIG_MTD) if defined(&CONFIG_MTD);
undef(&CONFIG_PARPORT) if defined(&CONFIG_PARPORT);
unless(defined(&CONFIG_PNP)) {
    sub CONFIG_PNP () {	1;}
}
unless(defined(&CONFIG_ISAPNP)) {
    sub CONFIG_ISAPNP () {	1;}
}
unless(defined(&CONFIG_BLK_DEV_FD)) {
    sub CONFIG_BLK_DEV_FD () {	1;}
}
undef(&CONFIG_BLK_DEV_XD) if defined(&CONFIG_BLK_DEV_XD);
undef(&CONFIG_PARIDE) if defined(&CONFIG_PARIDE);
undef(&CONFIG_BLK_CPQ_DA) if defined(&CONFIG_BLK_CPQ_DA);
undef(&CONFIG_BLK_CPQ_CISS_DA) if defined(&CONFIG_BLK_CPQ_CISS_DA);
undef(&CONFIG_CISS_SCSI_TAPE) if defined(&CONFIG_CISS_SCSI_TAPE);
undef(&CONFIG_BLK_DEV_DAC960) if defined(&CONFIG_BLK_DEV_DAC960);
undef(&CONFIG_BLK_DEV_UMEM) if defined(&CONFIG_BLK_DEV_UMEM);
undef(&CONFIG_BLK_DEV_LOOP) if defined(&CONFIG_BLK_DEV_LOOP);
undef(&CONFIG_BLK_DEV_NBD) if defined(&CONFIG_BLK_DEV_NBD);
undef(&CONFIG_BLK_DEV_RAM) if defined(&CONFIG_BLK_DEV_RAM);
undef(&CONFIG_BLK_DEV_INITRD) if defined(&CONFIG_BLK_DEV_INITRD);
undef(&CONFIG_BLK_STATS) if defined(&CONFIG_BLK_STATS);
undef(&CONFIG_MD) if defined(&CONFIG_MD);
undef(&CONFIG_BLK_DEV_MD) if defined(&CONFIG_BLK_DEV_MD);
undef(&CONFIG_MD_LINEAR) if defined(&CONFIG_MD_LINEAR);
undef(&CONFIG_MD_RAID0) if defined(&CONFIG_MD_RAID0);
undef(&CONFIG_MD_RAID1) if defined(&CONFIG_MD_RAID1);
undef(&CONFIG_MD_RAID5) if defined(&CONFIG_MD_RAID5);
undef(&CONFIG_MD_MULTIPATH) if defined(&CONFIG_MD_MULTIPATH);
undef(&CONFIG_BLK_DEV_LVM) if defined(&CONFIG_BLK_DEV_LVM);
unless(defined(&CONFIG_PACKET)) {
    sub CONFIG_PACKET () {	1;}
}
undef(&CONFIG_PACKET_MMAP) if defined(&CONFIG_PACKET_MMAP);
undef(&CONFIG_NETLINK_DEV) if defined(&CONFIG_NETLINK_DEV);
undef(&CONFIG_NETFILTER) if defined(&CONFIG_NETFILTER);
undef(&CONFIG_FILTER) if defined(&CONFIG_FILTER);
unless(defined(&CONFIG_UNIX)) {
    sub CONFIG_UNIX () {	1;}
}
unless(defined(&CONFIG_INET)) {
    sub CONFIG_INET () {	1;}
}
unless(defined(&CONFIG_IP_MULTICAST)) {
    sub CONFIG_IP_MULTICAST () {	1;}
}
undef(&CONFIG_IP_ADVANCED_ROUTER) if defined(&CONFIG_IP_ADVANCED_ROUTER);
undef(&CONFIG_IP_PNP) if defined(&CONFIG_IP_PNP);
undef(&CONFIG_NET_IPIP) if defined(&CONFIG_NET_IPIP);
undef(&CONFIG_NET_IPGRE) if defined(&CONFIG_NET_IPGRE);
undef(&CONFIG_IP_MROUTE) if defined(&CONFIG_IP_MROUTE);
undef(&CONFIG_INET_ECN) if defined(&CONFIG_INET_ECN);
undef(&CONFIG_SYN_COOKIES) if defined(&CONFIG_SYN_COOKIES);
undef(&CONFIG_VLAN_8021Q) if defined(&CONFIG_VLAN_8021Q);
undef(&CONFIG_IPX) if defined(&CONFIG_IPX);
undef(&CONFIG_ATALK) if defined(&CONFIG_ATALK);
undef(&CONFIG_DEV_APPLETALK) if defined(&CONFIG_DEV_APPLETALK);
undef(&CONFIG_DECNET) if defined(&CONFIG_DECNET);
undef(&CONFIG_BRIDGE) if defined(&CONFIG_BRIDGE);
undef(&CONFIG_NET_SCHED) if defined(&CONFIG_NET_SCHED);
undef(&CONFIG_NET_PKTGEN) if defined(&CONFIG_NET_PKTGEN);
undef(&CONFIG_PHONE) if defined(&CONFIG_PHONE);
undef(&CONFIG_PHONE_IXJ) if defined(&CONFIG_PHONE_IXJ);
undef(&CONFIG_PHONE_IXJ_PCMCIA) if defined(&CONFIG_PHONE_IXJ_PCMCIA);
unless(defined(&CONFIG_IDE)) {
    sub CONFIG_IDE () {	1;}
}
unless(defined(&CONFIG_BLK_DEV_IDE)) {
    sub CONFIG_BLK_DEV_IDE () {	1;}
}
undef(&CONFIG_BLK_DEV_HD_IDE) if defined(&CONFIG_BLK_DEV_HD_IDE);
undef(&CONFIG_BLK_DEV_HD) if defined(&CONFIG_BLK_DEV_HD);
unless(defined(&CONFIG_BLK_DEV_IDEDISK)) {
    sub CONFIG_BLK_DEV_IDEDISK () {	1;}
}
unless(defined(&CONFIG_IDEDISK_MULTI_MODE)) {
    sub CONFIG_IDEDISK_MULTI_MODE () {	1;}
}
undef(&CONFIG_IDEDISK_STROKE) if defined(&CONFIG_IDEDISK_STROKE);
undef(&CONFIG_BLK_DEV_IDECS) if defined(&CONFIG_BLK_DEV_IDECS);
unless(defined(&CONFIG_BLK_DEV_IDECD)) {
    sub CONFIG_BLK_DEV_IDECD () {	1;}
}
undef(&CONFIG_BLK_DEV_IDETAPE) if defined(&CONFIG_BLK_DEV_IDETAPE);
undef(&CONFIG_BLK_DEV_IDEFLOPPY) if defined(&CONFIG_BLK_DEV_IDEFLOPPY);
undef(&CONFIG_BLK_DEV_IDESCSI) if defined(&CONFIG_BLK_DEV_IDESCSI);
undef(&CONFIG_IDE_TASK_IOCTL) if defined(&CONFIG_IDE_TASK_IOCTL);
unless(defined(&CONFIG_BLK_DEV_CMD640)) {
    sub CONFIG_BLK_DEV_CMD640 () {	1;}
}
undef(&CONFIG_BLK_DEV_CMD640_ENHANCED) if defined(&CONFIG_BLK_DEV_CMD640_ENHANCED);
undef(&CONFIG_BLK_DEV_ISAPNP) if defined(&CONFIG_BLK_DEV_ISAPNP);
unless(defined(&CONFIG_BLK_DEV_IDEPCI)) {
    sub CONFIG_BLK_DEV_IDEPCI () {	1;}
}
undef(&CONFIG_BLK_DEV_GENERIC) if defined(&CONFIG_BLK_DEV_GENERIC);
unless(defined(&CONFIG_IDEPCI_SHARE_IRQ)) {
    sub CONFIG_IDEPCI_SHARE_IRQ () {	1;}
}
unless(defined(&CONFIG_BLK_DEV_IDEDMA_PCI)) {
    sub CONFIG_BLK_DEV_IDEDMA_PCI () {	1;}
}
undef(&CONFIG_BLK_DEV_OFFBOARD) if defined(&CONFIG_BLK_DEV_OFFBOARD);
undef(&CONFIG_BLK_DEV_IDEDMA_FORCED) if defined(&CONFIG_BLK_DEV_IDEDMA_FORCED);
unless(defined(&CONFIG_IDEDMA_PCI_AUTO)) {
    sub CONFIG_IDEDMA_PCI_AUTO () {	1;}
}
undef(&CONFIG_IDEDMA_ONLYDISK) if defined(&CONFIG_IDEDMA_ONLYDISK);
unless(defined(&CONFIG_BLK_DEV_IDEDMA)) {
    sub CONFIG_BLK_DEV_IDEDMA () {	1;}
}
undef(&CONFIG_IDEDMA_PCI_WIP) if defined(&CONFIG_IDEDMA_PCI_WIP);
undef(&CONFIG_BLK_DEV_ADMA100) if defined(&CONFIG_BLK_DEV_ADMA100);
undef(&CONFIG_BLK_DEV_AEC62XX) if defined(&CONFIG_BLK_DEV_AEC62XX);
undef(&CONFIG_BLK_DEV_ALI15X3) if defined(&CONFIG_BLK_DEV_ALI15X3);
undef(&CONFIG_WDC_ALI15X3) if defined(&CONFIG_WDC_ALI15X3);
undef(&CONFIG_BLK_DEV_AMD74XX) if defined(&CONFIG_BLK_DEV_AMD74XX);
undef(&CONFIG_AMD74XX_OVERRIDE) if defined(&CONFIG_AMD74XX_OVERRIDE);
undef(&CONFIG_BLK_DEV_CMD64X) if defined(&CONFIG_BLK_DEV_CMD64X);
undef(&CONFIG_BLK_DEV_TRIFLEX) if defined(&CONFIG_BLK_DEV_TRIFLEX);
undef(&CONFIG_BLK_DEV_CY82C693) if defined(&CONFIG_BLK_DEV_CY82C693);
undef(&CONFIG_BLK_DEV_CS5530) if defined(&CONFIG_BLK_DEV_CS5530);
undef(&CONFIG_BLK_DEV_HPT34X) if defined(&CONFIG_BLK_DEV_HPT34X);
undef(&CONFIG_HPT34X_AUTODMA) if defined(&CONFIG_HPT34X_AUTODMA);
undef(&CONFIG_BLK_DEV_HPT366) if defined(&CONFIG_BLK_DEV_HPT366);
unless(defined(&CONFIG_BLK_DEV_PIIX)) {
    sub CONFIG_BLK_DEV_PIIX () {	1;}
}
undef(&CONFIG_BLK_DEV_NS87415) if defined(&CONFIG_BLK_DEV_NS87415);
undef(&CONFIG_BLK_DEV_OPTI621) if defined(&CONFIG_BLK_DEV_OPTI621);
undef(&CONFIG_BLK_DEV_PDC202XX_OLD) if defined(&CONFIG_BLK_DEV_PDC202XX_OLD);
undef(&CONFIG_PDC202XX_BURST) if defined(&CONFIG_PDC202XX_BURST);
undef(&CONFIG_BLK_DEV_PDC202XX_NEW) if defined(&CONFIG_BLK_DEV_PDC202XX_NEW);
unless(defined(&CONFIG_BLK_DEV_RZ1000)) {
    sub CONFIG_BLK_DEV_RZ1000 () {	1;}
}
undef(&CONFIG_BLK_DEV_SC1200) if defined(&CONFIG_BLK_DEV_SC1200);
undef(&CONFIG_BLK_DEV_SVWKS) if defined(&CONFIG_BLK_DEV_SVWKS);
undef(&CONFIG_BLK_DEV_SIIMAGE) if defined(&CONFIG_BLK_DEV_SIIMAGE);
undef(&CONFIG_BLK_DEV_SIS5513) if defined(&CONFIG_BLK_DEV_SIS5513);
undef(&CONFIG_BLK_DEV_SLC90E66) if defined(&CONFIG_BLK_DEV_SLC90E66);
undef(&CONFIG_BLK_DEV_TRM290) if defined(&CONFIG_BLK_DEV_TRM290);
undef(&CONFIG_BLK_DEV_VIA82CXXX) if defined(&CONFIG_BLK_DEV_VIA82CXXX);
undef(&CONFIG_IDE_CHIPSETS) if defined(&CONFIG_IDE_CHIPSETS);
unless(defined(&CONFIG_IDEDMA_AUTO)) {
    sub CONFIG_IDEDMA_AUTO () {	1;}
}
undef(&CONFIG_IDEDMA_IVB) if defined(&CONFIG_IDEDMA_IVB);
undef(&CONFIG_DMA_NONPCI) if defined(&CONFIG_DMA_NONPCI);
unless(defined(&CONFIG_BLK_DEV_IDE_MODES)) {
    sub CONFIG_BLK_DEV_IDE_MODES () {	1;}
}
undef(&CONFIG_BLK_DEV_ATARAID) if defined(&CONFIG_BLK_DEV_ATARAID);
undef(&CONFIG_BLK_DEV_ATARAID_PDC) if defined(&CONFIG_BLK_DEV_ATARAID_PDC);
undef(&CONFIG_BLK_DEV_ATARAID_HPT) if defined(&CONFIG_BLK_DEV_ATARAID_HPT);
undef(&CONFIG_BLK_DEV_ATARAID_SII) if defined(&CONFIG_BLK_DEV_ATARAID_SII);
unless(defined(&CONFIG_SCSI)) {
    sub CONFIG_SCSI () {	1;}
}
unless(defined(&CONFIG_BLK_DEV_SD)) {
    sub CONFIG_BLK_DEV_SD () {	1;}
}
unless(defined(&CONFIG_SD_EXTRA_DEVS)) {
    sub CONFIG_SD_EXTRA_DEVS () {	(40);}
}
undef(&CONFIG_CHR_DEV_ST) if defined(&CONFIG_CHR_DEV_ST);
undef(&CONFIG_CHR_DEV_OSST) if defined(&CONFIG_CHR_DEV_OSST);
undef(&CONFIG_BLK_DEV_SR) if defined(&CONFIG_BLK_DEV_SR);
undef(&CONFIG_CHR_DEV_SG) if defined(&CONFIG_CHR_DEV_SG);
unless(defined(&CONFIG_SCSI_DEBUG_QUEUES)) {
    sub CONFIG_SCSI_DEBUG_QUEUES () {	1;}
}
unless(defined(&CONFIG_SCSI_MULTI_LUN)) {
    sub CONFIG_SCSI_MULTI_LUN () {	1;}
}
unless(defined(&CONFIG_SCSI_CONSTANTS)) {
    sub CONFIG_SCSI_CONSTANTS () {	1;}
}
undef(&CONFIG_SCSI_LOGGING) if defined(&CONFIG_SCSI_LOGGING);
undef(&CONFIG_BLK_DEV_3W_XXXX_RAID) if defined(&CONFIG_BLK_DEV_3W_XXXX_RAID);
undef(&CONFIG_SCSI_7000FASST) if defined(&CONFIG_SCSI_7000FASST);
undef(&CONFIG_SCSI_ACARD) if defined(&CONFIG_SCSI_ACARD);
undef(&CONFIG_SCSI_AHA152X) if defined(&CONFIG_SCSI_AHA152X);
undef(&CONFIG_SCSI_AHA1542) if defined(&CONFIG_SCSI_AHA1542);
undef(&CONFIG_SCSI_AHA1740) if defined(&CONFIG_SCSI_AHA1740);
undef(&CONFIG_SCSI_AIC7XXX) if defined(&CONFIG_SCSI_AIC7XXX);
undef(&CONFIG_SCSI_AIC79XX) if defined(&CONFIG_SCSI_AIC79XX);
undef(&CONFIG_SCSI_AIC7XXX_OLD) if defined(&CONFIG_SCSI_AIC7XXX_OLD);
undef(&CONFIG_SCSI_DPT_I2O) if defined(&CONFIG_SCSI_DPT_I2O);
undef(&CONFIG_SCSI_ADVANSYS) if defined(&CONFIG_SCSI_ADVANSYS);
undef(&CONFIG_SCSI_IN2000) if defined(&CONFIG_SCSI_IN2000);
undef(&CONFIG_SCSI_AM53C974) if defined(&CONFIG_SCSI_AM53C974);
undef(&CONFIG_SCSI_MEGARAID) if defined(&CONFIG_SCSI_MEGARAID);
undef(&CONFIG_SCSI_BUSLOGIC) if defined(&CONFIG_SCSI_BUSLOGIC);
undef(&CONFIG_SCSI_CPQFCTS) if defined(&CONFIG_SCSI_CPQFCTS);
undef(&CONFIG_SCSI_DMX3191D) if defined(&CONFIG_SCSI_DMX3191D);
undef(&CONFIG_SCSI_DTC3280) if defined(&CONFIG_SCSI_DTC3280);
undef(&CONFIG_SCSI_EATA) if defined(&CONFIG_SCSI_EATA);
undef(&CONFIG_SCSI_EATA_DMA) if defined(&CONFIG_SCSI_EATA_DMA);
undef(&CONFIG_SCSI_EATA_PIO) if defined(&CONFIG_SCSI_EATA_PIO);
undef(&CONFIG_SCSI_FUTURE_DOMAIN) if defined(&CONFIG_SCSI_FUTURE_DOMAIN);
undef(&CONFIG_SCSI_GDTH) if defined(&CONFIG_SCSI_GDTH);
undef(&CONFIG_SCSI_GENERIC_NCR5380) if defined(&CONFIG_SCSI_GENERIC_NCR5380);
undef(&CONFIG_SCSI_IPS) if defined(&CONFIG_SCSI_IPS);
undef(&CONFIG_SCSI_INITIO) if defined(&CONFIG_SCSI_INITIO);
undef(&CONFIG_SCSI_INIA100) if defined(&CONFIG_SCSI_INIA100);
undef(&CONFIG_SCSI_NCR53C406A) if defined(&CONFIG_SCSI_NCR53C406A);
undef(&CONFIG_SCSI_NCR53C7xx) if defined(&CONFIG_SCSI_NCR53C7xx);
undef(&CONFIG_SCSI_SYM53C8XX_2) if defined(&CONFIG_SCSI_SYM53C8XX_2);
undef(&CONFIG_SCSI_NCR53C8XX) if defined(&CONFIG_SCSI_NCR53C8XX);
unless(defined(&CONFIG_SCSI_SYM53C8XX)) {
    sub CONFIG_SCSI_SYM53C8XX () {	1;}
}
unless(defined(&CONFIG_SCSI_NCR53C8XX_DEFAULT_TAGS)) {
    sub CONFIG_SCSI_NCR53C8XX_DEFAULT_TAGS () {	(4);}
}
unless(defined(&CONFIG_SCSI_NCR53C8XX_MAX_TAGS)) {
    sub CONFIG_SCSI_NCR53C8XX_MAX_TAGS () {	(32);}
}
unless(defined(&CONFIG_SCSI_NCR53C8XX_SYNC)) {
    sub CONFIG_SCSI_NCR53C8XX_SYNC () {	(20);}
}
undef(&CONFIG_SCSI_NCR53C8XX_PROFILE) if defined(&CONFIG_SCSI_NCR53C8XX_PROFILE);
undef(&CONFIG_SCSI_NCR53C8XX_IOMAPPED) if defined(&CONFIG_SCSI_NCR53C8XX_IOMAPPED);
undef(&CONFIG_SCSI_NCR53C8XX_PQS_PDS) if defined(&CONFIG_SCSI_NCR53C8XX_PQS_PDS);
undef(&CONFIG_SCSI_PAS16) if defined(&CONFIG_SCSI_PAS16);
undef(&CONFIG_SCSI_PCI2000) if defined(&CONFIG_SCSI_PCI2000);
undef(&CONFIG_SCSI_PCI2220I) if defined(&CONFIG_SCSI_PCI2220I);
undef(&CONFIG_SCSI_PSI240I) if defined(&CONFIG_SCSI_PSI240I);
undef(&CONFIG_SCSI_QLOGIC_FAS) if defined(&CONFIG_SCSI_QLOGIC_FAS);
undef(&CONFIG_SCSI_QLOGIC_ISP) if defined(&CONFIG_SCSI_QLOGIC_ISP);
undef(&CONFIG_SCSI_QLOGIC_FC) if defined(&CONFIG_SCSI_QLOGIC_FC);
undef(&CONFIG_SCSI_QLOGIC_1280) if defined(&CONFIG_SCSI_QLOGIC_1280);
undef(&CONFIG_SCSI_SEAGATE) if defined(&CONFIG_SCSI_SEAGATE);
undef(&CONFIG_SCSI_SIM710) if defined(&CONFIG_SCSI_SIM710);
undef(&CONFIG_SCSI_SYM53C416) if defined(&CONFIG_SCSI_SYM53C416);
undef(&CONFIG_SCSI_DC390T) if defined(&CONFIG_SCSI_DC390T);
undef(&CONFIG_SCSI_T128) if defined(&CONFIG_SCSI_T128);
undef(&CONFIG_SCSI_U14_34F) if defined(&CONFIG_SCSI_U14_34F);
undef(&CONFIG_SCSI_ULTRASTOR) if defined(&CONFIG_SCSI_ULTRASTOR);
undef(&CONFIG_SCSI_NSP32) if defined(&CONFIG_SCSI_NSP32);
undef(&CONFIG_SCSI_PCMCIA) if defined(&CONFIG_SCSI_PCMCIA);
undef(&CONFIG_FUSION) if defined(&CONFIG_FUSION);
undef(&CONFIG_FUSION_BOOT) if defined(&CONFIG_FUSION_BOOT);
undef(&CONFIG_FUSION_ISENSE) if defined(&CONFIG_FUSION_ISENSE);
undef(&CONFIG_FUSION_CTL) if defined(&CONFIG_FUSION_CTL);
undef(&CONFIG_FUSION_LAN) if defined(&CONFIG_FUSION_LAN);
undef(&CONFIG_I2O) if defined(&CONFIG_I2O);
undef(&CONFIG_I2O_PCI) if defined(&CONFIG_I2O_PCI);
undef(&CONFIG_I2O_BLOCK) if defined(&CONFIG_I2O_BLOCK);
undef(&CONFIG_I2O_LAN) if defined(&CONFIG_I2O_LAN);
undef(&CONFIG_I2O_SCSI) if defined(&CONFIG_I2O_SCSI);
undef(&CONFIG_I2O_PROC) if defined(&CONFIG_I2O_PROC);
unless(defined(&CONFIG_NETDEVICES)) {
    sub CONFIG_NETDEVICES () {	1;}
}
undef(&CONFIG_ARCNET) if defined(&CONFIG_ARCNET);
undef(&CONFIG_DUMMY) if defined(&CONFIG_DUMMY);
unless(defined(&CONFIG_DUMMY_MODULE)) {
    sub CONFIG_DUMMY_MODULE () {	1;}
}
undef(&CONFIG_BONDING) if defined(&CONFIG_BONDING);
undef(&CONFIG_EQUALIZER) if defined(&CONFIG_EQUALIZER);
undef(&CONFIG_TUN) if defined(&CONFIG_TUN);
undef(&CONFIG_NET_SB1000) if defined(&CONFIG_NET_SB1000);
unless(defined(&CONFIG_NET_ETHERNET)) {
    sub CONFIG_NET_ETHERNET () {	1;}
}
undef(&CONFIG_SUNLANCE) if defined(&CONFIG_SUNLANCE);
undef(&CONFIG_HAPPYMEAL) if defined(&CONFIG_HAPPYMEAL);
undef(&CONFIG_SUNBMAC) if defined(&CONFIG_SUNBMAC);
undef(&CONFIG_SUNQE) if defined(&CONFIG_SUNQE);
undef(&CONFIG_SUNGEM) if defined(&CONFIG_SUNGEM);
undef(&CONFIG_NET_VENDOR_3COM) if defined(&CONFIG_NET_VENDOR_3COM);
undef(&CONFIG_LANCE) if defined(&CONFIG_LANCE);
undef(&CONFIG_NET_VENDOR_SMC) if defined(&CONFIG_NET_VENDOR_SMC);
undef(&CONFIG_NET_VENDOR_RACAL) if defined(&CONFIG_NET_VENDOR_RACAL);
undef(&CONFIG_AT1700) if defined(&CONFIG_AT1700);
undef(&CONFIG_DEPCA) if defined(&CONFIG_DEPCA);
undef(&CONFIG_HP100) if defined(&CONFIG_HP100);
undef(&CONFIG_NET_ISA) if defined(&CONFIG_NET_ISA);
unless(defined(&CONFIG_NET_PCI)) {
    sub CONFIG_NET_PCI () {	1;}
}
undef(&CONFIG_PCNET32) if defined(&CONFIG_PCNET32);
undef(&CONFIG_AMD8111_ETH) if defined(&CONFIG_AMD8111_ETH);
undef(&CONFIG_ADAPTEC_STARFIRE) if defined(&CONFIG_ADAPTEC_STARFIRE);
undef(&CONFIG_AC3200) if defined(&CONFIG_AC3200);
undef(&CONFIG_APRICOT) if defined(&CONFIG_APRICOT);
undef(&CONFIG_B44) if defined(&CONFIG_B44);
undef(&CONFIG_CS89x0) if defined(&CONFIG_CS89x0);
undef(&CONFIG_TULIP) if defined(&CONFIG_TULIP);
undef(&CONFIG_DE4X5) if defined(&CONFIG_DE4X5);
undef(&CONFIG_DGRS) if defined(&CONFIG_DGRS);
undef(&CONFIG_DM9102) if defined(&CONFIG_DM9102);
unless(defined(&CONFIG_EEPRO100)) {
    sub CONFIG_EEPRO100 () {	1;}
}
undef(&CONFIG_EEPRO100_PIO) if defined(&CONFIG_EEPRO100_PIO);
undef(&CONFIG_E100) if defined(&CONFIG_E100);
undef(&CONFIG_LNE390) if defined(&CONFIG_LNE390);
undef(&CONFIG_FEALNX) if defined(&CONFIG_FEALNX);
undef(&CONFIG_NATSEMI) if defined(&CONFIG_NATSEMI);
undef(&CONFIG_NE2K_PCI) if defined(&CONFIG_NE2K_PCI);
undef(&CONFIG_NE3210) if defined(&CONFIG_NE3210);
undef(&CONFIG_ES3210) if defined(&CONFIG_ES3210);
undef(&CONFIG_8139CP) if defined(&CONFIG_8139CP);
undef(&CONFIG_8139TOO) if defined(&CONFIG_8139TOO);
undef(&CONFIG_8139TOO_PIO) if defined(&CONFIG_8139TOO_PIO);
undef(&CONFIG_8139TOO_TUNE_TWISTER) if defined(&CONFIG_8139TOO_TUNE_TWISTER);
undef(&CONFIG_8139TOO_8129) if defined(&CONFIG_8139TOO_8129);
undef(&CONFIG_8139_OLD_RX_RESET) if defined(&CONFIG_8139_OLD_RX_RESET);
undef(&CONFIG_SIS900) if defined(&CONFIG_SIS900);
undef(&CONFIG_EPIC100) if defined(&CONFIG_EPIC100);
undef(&CONFIG_SUNDANCE) if defined(&CONFIG_SUNDANCE);
undef(&CONFIG_SUNDANCE_MMIO) if defined(&CONFIG_SUNDANCE_MMIO);
undef(&CONFIG_TLAN) if defined(&CONFIG_TLAN);
undef(&CONFIG_VIA_RHINE) if defined(&CONFIG_VIA_RHINE);
undef(&CONFIG_VIA_RHINE_MMIO) if defined(&CONFIG_VIA_RHINE_MMIO);
undef(&CONFIG_WINBOND_840) if defined(&CONFIG_WINBOND_840);
undef(&CONFIG_NET_POCKET) if defined(&CONFIG_NET_POCKET);
undef(&CONFIG_ACENIC) if defined(&CONFIG_ACENIC);
undef(&CONFIG_DL2K) if defined(&CONFIG_DL2K);
undef(&CONFIG_E1000) if defined(&CONFIG_E1000);
undef(&CONFIG_MYRI_SBUS) if defined(&CONFIG_MYRI_SBUS);
undef(&CONFIG_NS83820) if defined(&CONFIG_NS83820);
undef(&CONFIG_HAMACHI) if defined(&CONFIG_HAMACHI);
undef(&CONFIG_YELLOWFIN) if defined(&CONFIG_YELLOWFIN);
undef(&CONFIG_R8169) if defined(&CONFIG_R8169);
undef(&CONFIG_SK98LIN) if defined(&CONFIG_SK98LIN);
undef(&CONFIG_TIGON3) if defined(&CONFIG_TIGON3);
undef(&CONFIG_FDDI) if defined(&CONFIG_FDDI);
undef(&CONFIG_PLIP) if defined(&CONFIG_PLIP);
undef(&CONFIG_PPP) if defined(&CONFIG_PPP);
undef(&CONFIG_SLIP) if defined(&CONFIG_SLIP);
undef(&CONFIG_NET_RADIO) if defined(&CONFIG_NET_RADIO);
undef(&CONFIG_TR) if defined(&CONFIG_TR);
undef(&CONFIG_NET_FC) if defined(&CONFIG_NET_FC);
undef(&CONFIG_WAN) if defined(&CONFIG_WAN);
unless(defined(&CONFIG_NET_PCMCIA)) {
    sub CONFIG_NET_PCMCIA () {	1;}
}
undef(&CONFIG_PCMCIA_3C589) if defined(&CONFIG_PCMCIA_3C589);
undef(&CONFIG_PCMCIA_3C574) if defined(&CONFIG_PCMCIA_3C574);
undef(&CONFIG_PCMCIA_FMVJ18X) if defined(&CONFIG_PCMCIA_FMVJ18X);
unless(defined(&CONFIG_PCMCIA_PCNET)) {
    sub CONFIG_PCMCIA_PCNET () {	1;}
}
undef(&CONFIG_PCMCIA_AXNET) if defined(&CONFIG_PCMCIA_AXNET);
undef(&CONFIG_PCMCIA_NMCLAN) if defined(&CONFIG_PCMCIA_NMCLAN);
undef(&CONFIG_PCMCIA_SMC91C92) if defined(&CONFIG_PCMCIA_SMC91C92);
undef(&CONFIG_PCMCIA_XIRC2PS) if defined(&CONFIG_PCMCIA_XIRC2PS);
undef(&CONFIG_ARCNET_COM20020_CS) if defined(&CONFIG_ARCNET_COM20020_CS);
undef(&CONFIG_PCMCIA_IBMTR) if defined(&CONFIG_PCMCIA_IBMTR);
undef(&CONFIG_PCMCIA_XIRCOM) if defined(&CONFIG_PCMCIA_XIRCOM);
undef(&CONFIG_PCMCIA_XIRTULIP) if defined(&CONFIG_PCMCIA_XIRTULIP);
unless(defined(&CONFIG_NET_PCMCIA_RADIO)) {
    sub CONFIG_NET_PCMCIA_RADIO () {	1;}
}
unless(defined(&CONFIG_PCMCIA_RAYCS)) {
    sub CONFIG_PCMCIA_RAYCS () {	1;}
}
undef(&CONFIG_PCMCIA_NETWAVE) if defined(&CONFIG_PCMCIA_NETWAVE);
undef(&CONFIG_PCMCIA_WAVELAN) if defined(&CONFIG_PCMCIA_WAVELAN);
undef(&CONFIG_AIRONET4500_CS) if defined(&CONFIG_AIRONET4500_CS);
undef(&CONFIG_HAMRADIO) if defined(&CONFIG_HAMRADIO);
undef(&CONFIG_IRDA) if defined(&CONFIG_IRDA);
undef(&CONFIG_ISDN) if defined(&CONFIG_ISDN);
undef(&CONFIG_CD_NO_IDESCSI) if defined(&CONFIG_CD_NO_IDESCSI);
undef(&CONFIG_INPUT) if defined(&CONFIG_INPUT);
undef(&CONFIG_INPUT_KEYBDEV) if defined(&CONFIG_INPUT_KEYBDEV);
undef(&CONFIG_INPUT_MOUSEDEV) if defined(&CONFIG_INPUT_MOUSEDEV);
undef(&CONFIG_INPUT_JOYDEV) if defined(&CONFIG_INPUT_JOYDEV);
undef(&CONFIG_INPUT_EVDEV) if defined(&CONFIG_INPUT_EVDEV);
unless(defined(&CONFIG_VT)) {
    sub CONFIG_VT () {	1;}
}
unless(defined(&CONFIG_VT_CONSOLE)) {
    sub CONFIG_VT_CONSOLE () {	1;}
}
unless(defined(&CONFIG_SERIAL)) {
    sub CONFIG_SERIAL () {	1;}
}
undef(&CONFIG_SERIAL_CONSOLE) if defined(&CONFIG_SERIAL_CONSOLE);
undef(&CONFIG_SERIAL_EXTENDED) if defined(&CONFIG_SERIAL_EXTENDED);
undef(&CONFIG_SERIAL_NONSTANDARD) if defined(&CONFIG_SERIAL_NONSTANDARD);
unless(defined(&CONFIG_UNIX98_PTYS)) {
    sub CONFIG_UNIX98_PTYS () {	1;}
}
unless(defined(&CONFIG_UNIX98_PTY_COUNT)) {
    sub CONFIG_UNIX98_PTY_COUNT () {	(256);}
}
undef(&CONFIG_I2C) if defined(&CONFIG_I2C);
undef(&CONFIG_BUSMOUSE) if defined(&CONFIG_BUSMOUSE);
unless(defined(&CONFIG_MOUSE)) {
    sub CONFIG_MOUSE () {	1;}
}
unless(defined(&CONFIG_PSMOUSE)) {
    sub CONFIG_PSMOUSE () {	1;}
}
undef(&CONFIG_82C710_MOUSE) if defined(&CONFIG_82C710_MOUSE);
undef(&CONFIG_PC110_PAD) if defined(&CONFIG_PC110_PAD);
undef(&CONFIG_MK712_MOUSE) if defined(&CONFIG_MK712_MOUSE);
undef(&CONFIG_INPUT_GAMEPORT) if defined(&CONFIG_INPUT_GAMEPORT);
undef(&CONFIG_QIC02_TAPE) if defined(&CONFIG_QIC02_TAPE);
undef(&CONFIG_IPMI_HANDLER) if defined(&CONFIG_IPMI_HANDLER);
undef(&CONFIG_IPMI_PANIC_EVENT) if defined(&CONFIG_IPMI_PANIC_EVENT);
undef(&CONFIG_IPMI_DEVICE_INTERFACE) if defined(&CONFIG_IPMI_DEVICE_INTERFACE);
undef(&CONFIG_IPMI_KCS) if defined(&CONFIG_IPMI_KCS);
undef(&CONFIG_IPMI_WATCHDOG) if defined(&CONFIG_IPMI_WATCHDOG);
undef(&CONFIG_WATCHDOG) if defined(&CONFIG_WATCHDOG);
undef(&CONFIG_SCx200_GPIO) if defined(&CONFIG_SCx200_GPIO);
undef(&CONFIG_AMD_RNG) if defined(&CONFIG_AMD_RNG);
undef(&CONFIG_INTEL_RNG) if defined(&CONFIG_INTEL_RNG);
undef(&CONFIG_AMD_PM768) if defined(&CONFIG_AMD_PM768);
undef(&CONFIG_NVRAM) if defined(&CONFIG_NVRAM);
undef(&CONFIG_RTC) if defined(&CONFIG_RTC);
undef(&CONFIG_DTLK) if defined(&CONFIG_DTLK);
undef(&CONFIG_R3964) if defined(&CONFIG_R3964);
undef(&CONFIG_APPLICOM) if defined(&CONFIG_APPLICOM);
undef(&CONFIG_FTAPE) if defined(&CONFIG_FTAPE);
unless(defined(&CONFIG_AGP)) {
    sub CONFIG_AGP () {	1;}
}
unless(defined(&CONFIG_AGP_INTEL)) {
    sub CONFIG_AGP_INTEL () {	1;}
}
unless(defined(&CONFIG_AGP_I810)) {
    sub CONFIG_AGP_I810 () {	1;}
}
unless(defined(&CONFIG_AGP_VIA)) {
    sub CONFIG_AGP_VIA () {	1;}
}
unless(defined(&CONFIG_AGP_AMD)) {
    sub CONFIG_AGP_AMD () {	1;}
}
undef(&CONFIG_AGP_AMD_8151) if defined(&CONFIG_AGP_AMD_8151);
unless(defined(&CONFIG_AGP_SIS)) {
    sub CONFIG_AGP_SIS () {	1;}
}
unless(defined(&CONFIG_AGP_ALI)) {
    sub CONFIG_AGP_ALI () {	1;}
}
undef(&CONFIG_AGP_SWORKS) if defined(&CONFIG_AGP_SWORKS);
undef(&CONFIG_AGP_NVIDIA) if defined(&CONFIG_AGP_NVIDIA);
unless(defined(&CONFIG_DRM)) {
    sub CONFIG_DRM () {	1;}
}
undef(&CONFIG_DRM_OLD) if defined(&CONFIG_DRM_OLD);
unless(defined(&CONFIG_DRM_NEW)) {
    sub CONFIG_DRM_NEW () {	1;}
}
unless(defined(&CONFIG_DRM_TDFX)) {
    sub CONFIG_DRM_TDFX () {	1;}
}
undef(&CONFIG_DRM_R128) if defined(&CONFIG_DRM_R128);
unless(defined(&CONFIG_DRM_RADEON)) {
    sub CONFIG_DRM_RADEON () {	1;}
}
unless(defined(&CONFIG_DRM_I810)) {
    sub CONFIG_DRM_I810 () {	1;}
}
unless(defined(&CONFIG_DRM_I810_XFREE_41)) {
    sub CONFIG_DRM_I810_XFREE_41 () {	1;}
}
undef(&CONFIG_DRM_I830) if defined(&CONFIG_DRM_I830);
undef(&CONFIG_DRM_MGA) if defined(&CONFIG_DRM_MGA);
undef(&CONFIG_DRM_SIS) if defined(&CONFIG_DRM_SIS);
undef(&CONFIG_PCMCIA_SERIAL_CS) if defined(&CONFIG_PCMCIA_SERIAL_CS);
undef(&CONFIG_SYNCLINK_CS) if defined(&CONFIG_SYNCLINK_CS);
undef(&CONFIG_MWAVE) if defined(&CONFIG_MWAVE);
undef(&CONFIG_VIDEO_DEV) if defined(&CONFIG_VIDEO_DEV);
undef(&CONFIG_QUOTA) if defined(&CONFIG_QUOTA);
undef(&CONFIG_QFMT_V2) if defined(&CONFIG_QFMT_V2);
undef(&CONFIG_AUTOFS_FS) if defined(&CONFIG_AUTOFS_FS);
unless(defined(&CONFIG_AUTOFS4_FS)) {
    sub CONFIG_AUTOFS4_FS () {	1;}
}
undef(&CONFIG_REISERFS_FS) if defined(&CONFIG_REISERFS_FS);
undef(&CONFIG_REISERFS_CHECK) if defined(&CONFIG_REISERFS_CHECK);
undef(&CONFIG_REISERFS_PROC_INFO) if defined(&CONFIG_REISERFS_PROC_INFO);
undef(&CONFIG_ADFS_FS) if defined(&CONFIG_ADFS_FS);
undef(&CONFIG_ADFS_FS_RW) if defined(&CONFIG_ADFS_FS_RW);
undef(&CONFIG_AFFS_FS) if defined(&CONFIG_AFFS_FS);
undef(&CONFIG_HFS_FS) if defined(&CONFIG_HFS_FS);
undef(&CONFIG_HFSPLUS_FS) if defined(&CONFIG_HFSPLUS_FS);
undef(&CONFIG_BEFS_FS) if defined(&CONFIG_BEFS_FS);
undef(&CONFIG_BEFS_DEBUG) if defined(&CONFIG_BEFS_DEBUG);
undef(&CONFIG_BFS_FS) if defined(&CONFIG_BFS_FS);
undef(&CONFIG_EXT3_FS) if defined(&CONFIG_EXT3_FS);
undef(&CONFIG_JBD) if defined(&CONFIG_JBD);
undef(&CONFIG_JBD_DEBUG) if defined(&CONFIG_JBD_DEBUG);
undef(&CONFIG_FAT_FS) if defined(&CONFIG_FAT_FS);
undef(&CONFIG_MSDOS_FS) if defined(&CONFIG_MSDOS_FS);
undef(&CONFIG_UMSDOS_FS) if defined(&CONFIG_UMSDOS_FS);
undef(&CONFIG_VFAT_FS) if defined(&CONFIG_VFAT_FS);
undef(&CONFIG_EFS_FS) if defined(&CONFIG_EFS_FS);
undef(&CONFIG_JFFS_FS) if defined(&CONFIG_JFFS_FS);
undef(&CONFIG_JFFS2_FS) if defined(&CONFIG_JFFS2_FS);
undef(&CONFIG_CRAMFS) if defined(&CONFIG_CRAMFS);
unless(defined(&CONFIG_TMPFS)) {
    sub CONFIG_TMPFS () {	1;}
}
unless(defined(&CONFIG_RAMFS)) {
    sub CONFIG_RAMFS () {	1;}
}
unless(defined(&CONFIG_ISO9660_FS)) {
    sub CONFIG_ISO9660_FS () {	1;}
}
undef(&CONFIG_JOLIET) if defined(&CONFIG_JOLIET);
undef(&CONFIG_ZISOFS) if defined(&CONFIG_ZISOFS);
undef(&CONFIG_JFS_FS) if defined(&CONFIG_JFS_FS);
undef(&CONFIG_JFS_DEBUG) if defined(&CONFIG_JFS_DEBUG);
undef(&CONFIG_JFS_STATISTICS) if defined(&CONFIG_JFS_STATISTICS);
undef(&CONFIG_MINIX_FS) if defined(&CONFIG_MINIX_FS);
undef(&CONFIG_VXFS_FS) if defined(&CONFIG_VXFS_FS);
undef(&CONFIG_NTFS_FS) if defined(&CONFIG_NTFS_FS);
undef(&CONFIG_NTFS_RW) if defined(&CONFIG_NTFS_RW);
undef(&CONFIG_HPFS_FS) if defined(&CONFIG_HPFS_FS);
unless(defined(&CONFIG_PROC_FS)) {
    sub CONFIG_PROC_FS () {	1;}
}
undef(&CONFIG_DEVFS_FS) if defined(&CONFIG_DEVFS_FS);
undef(&CONFIG_DEVFS_MOUNT) if defined(&CONFIG_DEVFS_MOUNT);
undef(&CONFIG_DEVFS_DEBUG) if defined(&CONFIG_DEVFS_DEBUG);
unless(defined(&CONFIG_DEVPTS_FS)) {
    sub CONFIG_DEVPTS_FS () {	1;}
}
undef(&CONFIG_QNX4FS_FS) if defined(&CONFIG_QNX4FS_FS);
undef(&CONFIG_QNX4FS_RW) if defined(&CONFIG_QNX4FS_RW);
undef(&CONFIG_ROMFS_FS) if defined(&CONFIG_ROMFS_FS);
unless(defined(&CONFIG_EXT2_FS)) {
    sub CONFIG_EXT2_FS () {	1;}
}
undef(&CONFIG_SYSV_FS) if defined(&CONFIG_SYSV_FS);
undef(&CONFIG_UDF_FS) if defined(&CONFIG_UDF_FS);
undef(&CONFIG_UDF_RW) if defined(&CONFIG_UDF_RW);
undef(&CONFIG_UFS_FS) if defined(&CONFIG_UFS_FS);
undef(&CONFIG_UFS_FS_WRITE) if defined(&CONFIG_UFS_FS_WRITE);
undef(&CONFIG_CODA_FS) if defined(&CONFIG_CODA_FS);
undef(&CONFIG_INTERMEZZO_FS) if defined(&CONFIG_INTERMEZZO_FS);
unless(defined(&CONFIG_NFS_FS)) {
    sub CONFIG_NFS_FS () {	1;}
}
undef(&CONFIG_NFS_V3) if defined(&CONFIG_NFS_V3);
undef(&CONFIG_NFS_DIRECTIO) if defined(&CONFIG_NFS_DIRECTIO);
undef(&CONFIG_ROOT_NFS) if defined(&CONFIG_ROOT_NFS);
unless(defined(&CONFIG_NFSD)) {
    sub CONFIG_NFSD () {	1;}
}
undef(&CONFIG_NFSD_V3) if defined(&CONFIG_NFSD_V3);
undef(&CONFIG_NFSD_TCP) if defined(&CONFIG_NFSD_TCP);
unless(defined(&CONFIG_SUNRPC)) {
    sub CONFIG_SUNRPC () {	1;}
}
unless(defined(&CONFIG_LOCKD)) {
    sub CONFIG_LOCKD () {	1;}
}
undef(&CONFIG_SMB_FS) if defined(&CONFIG_SMB_FS);
undef(&CONFIG_NCP_FS) if defined(&CONFIG_NCP_FS);
undef(&CONFIG_NCPFS_PACKET_SIGNING) if defined(&CONFIG_NCPFS_PACKET_SIGNING);
undef(&CONFIG_NCPFS_IOCTL_LOCKING) if defined(&CONFIG_NCPFS_IOCTL_LOCKING);
undef(&CONFIG_NCPFS_STRONG) if defined(&CONFIG_NCPFS_STRONG);
undef(&CONFIG_NCPFS_NFS_NS) if defined(&CONFIG_NCPFS_NFS_NS);
undef(&CONFIG_NCPFS_OS2_NS) if defined(&CONFIG_NCPFS_OS2_NS);
undef(&CONFIG_NCPFS_SMALLDOS) if defined(&CONFIG_NCPFS_SMALLDOS);
undef(&CONFIG_NCPFS_NLS) if defined(&CONFIG_NCPFS_NLS);
undef(&CONFIG_NCPFS_EXTRAS) if defined(&CONFIG_NCPFS_EXTRAS);
undef(&CONFIG_ZISOFS_FS) if defined(&CONFIG_ZISOFS_FS);
undef(&CONFIG_PARTITION_ADVANCED) if defined(&CONFIG_PARTITION_ADVANCED);
unless(defined(&CONFIG_MSDOS_PARTITION)) {
    sub CONFIG_MSDOS_PARTITION () {	1;}
}
undef(&CONFIG_SMB_NLS) if defined(&CONFIG_SMB_NLS);
undef(&CONFIG_NLS) if defined(&CONFIG_NLS);
unless(defined(&CONFIG_VGA_CONSOLE)) {
    sub CONFIG_VGA_CONSOLE () {	1;}
}
undef(&CONFIG_VIDEO_SELECT) if defined(&CONFIG_VIDEO_SELECT);
unless(defined(&CONFIG_SOUND)) {
    sub CONFIG_SOUND () {	1;}
}
undef(&CONFIG_SOUND_ALI5455) if defined(&CONFIG_SOUND_ALI5455);
undef(&CONFIG_SOUND_BT878) if defined(&CONFIG_SOUND_BT878);
undef(&CONFIG_SOUND_CMPCI) if defined(&CONFIG_SOUND_CMPCI);
undef(&CONFIG_SOUND_EMU10K1) if defined(&CONFIG_SOUND_EMU10K1);
undef(&CONFIG_MIDI_EMU10K1) if defined(&CONFIG_MIDI_EMU10K1);
undef(&CONFIG_SOUND_FUSION) if defined(&CONFIG_SOUND_FUSION);
undef(&CONFIG_SOUND_CS4281) if defined(&CONFIG_SOUND_CS4281);
undef(&CONFIG_SOUND_ES1370) if defined(&CONFIG_SOUND_ES1370);
unless(defined(&CONFIG_SOUND_ES1371)) {
    sub CONFIG_SOUND_ES1371 () {	1;}
}
undef(&CONFIG_SOUND_ESSSOLO1) if defined(&CONFIG_SOUND_ESSSOLO1);
undef(&CONFIG_SOUND_MAESTRO) if defined(&CONFIG_SOUND_MAESTRO);
undef(&CONFIG_SOUND_MAESTRO3) if defined(&CONFIG_SOUND_MAESTRO3);
undef(&CONFIG_SOUND_FORTE) if defined(&CONFIG_SOUND_FORTE);
undef(&CONFIG_SOUND_ICH) if defined(&CONFIG_SOUND_ICH);
undef(&CONFIG_SOUND_RME96XX) if defined(&CONFIG_SOUND_RME96XX);
undef(&CONFIG_SOUND_SONICVIBES) if defined(&CONFIG_SOUND_SONICVIBES);
undef(&CONFIG_SOUND_TRIDENT) if defined(&CONFIG_SOUND_TRIDENT);
undef(&CONFIG_SOUND_MSNDCLAS) if defined(&CONFIG_SOUND_MSNDCLAS);
undef(&CONFIG_SOUND_MSNDPIN) if defined(&CONFIG_SOUND_MSNDPIN);
undef(&CONFIG_SOUND_VIA82CXXX) if defined(&CONFIG_SOUND_VIA82CXXX);
undef(&CONFIG_MIDI_VIA82CXXX) if defined(&CONFIG_MIDI_VIA82CXXX);
undef(&CONFIG_SOUND_OSS) if defined(&CONFIG_SOUND_OSS);
undef(&CONFIG_SOUND_TVMIXER) if defined(&CONFIG_SOUND_TVMIXER);
unless(defined(&CONFIG_USB)) {
    sub CONFIG_USB () {	1;}
}
undef(&CONFIG_USB_DEBUG) if defined(&CONFIG_USB_DEBUG);
undef(&CONFIG_USB_DEVICEFS) if defined(&CONFIG_USB_DEVICEFS);
undef(&CONFIG_USB_BANDWIDTH) if defined(&CONFIG_USB_BANDWIDTH);
undef(&CONFIG_USB_EHCI_HCD) if defined(&CONFIG_USB_EHCI_HCD);
unless(defined(&CONFIG_USB_UHCI_ALT)) {
    sub CONFIG_USB_UHCI_ALT () {	1;}
}
undef(&CONFIG_USB_OHCI) if defined(&CONFIG_USB_OHCI);
undef(&CONFIG_USB_AUDIO) if defined(&CONFIG_USB_AUDIO);
undef(&CONFIG_USB_EMI26) if defined(&CONFIG_USB_EMI26);
undef(&CONFIG_USB_MIDI) if defined(&CONFIG_USB_MIDI);
unless(defined(&CONFIG_USB_STORAGE)) {
    sub CONFIG_USB_STORAGE () {	1;}
}
undef(&CONFIG_USB_STORAGE_DEBUG) if defined(&CONFIG_USB_STORAGE_DEBUG);
undef(&CONFIG_USB_STORAGE_DATAFAB) if defined(&CONFIG_USB_STORAGE_DATAFAB);
undef(&CONFIG_USB_STORAGE_FREECOM) if defined(&CONFIG_USB_STORAGE_FREECOM);
undef(&CONFIG_USB_STORAGE_ISD200) if defined(&CONFIG_USB_STORAGE_ISD200);
undef(&CONFIG_USB_STORAGE_DPCM) if defined(&CONFIG_USB_STORAGE_DPCM);
undef(&CONFIG_USB_STORAGE_HP8200e) if defined(&CONFIG_USB_STORAGE_HP8200e);
undef(&CONFIG_USB_STORAGE_SDDR09) if defined(&CONFIG_USB_STORAGE_SDDR09);
undef(&CONFIG_USB_STORAGE_SDDR55) if defined(&CONFIG_USB_STORAGE_SDDR55);
undef(&CONFIG_USB_STORAGE_JUMPSHOT) if defined(&CONFIG_USB_STORAGE_JUMPSHOT);
undef(&CONFIG_USB_ACM) if defined(&CONFIG_USB_ACM);
undef(&CONFIG_USB_PRINTER) if defined(&CONFIG_USB_PRINTER);
undef(&CONFIG_USB_HID) if defined(&CONFIG_USB_HID);
undef(&CONFIG_USB_HIDINPUT) if defined(&CONFIG_USB_HIDINPUT);
undef(&CONFIG_USB_HIDDEV) if defined(&CONFIG_USB_HIDDEV);
undef(&CONFIG_USB_KBD) if defined(&CONFIG_USB_KBD);
undef(&CONFIG_USB_MOUSE) if defined(&CONFIG_USB_MOUSE);
undef(&CONFIG_USB_AIPTEK) if defined(&CONFIG_USB_AIPTEK);
undef(&CONFIG_USB_WACOM) if defined(&CONFIG_USB_WACOM);
undef(&CONFIG_USB_KBTAB) if defined(&CONFIG_USB_KBTAB);
undef(&CONFIG_USB_POWERMATE) if defined(&CONFIG_USB_POWERMATE);
undef(&CONFIG_USB_DC2XX) if defined(&CONFIG_USB_DC2XX);
undef(&CONFIG_USB_MDC800) if defined(&CONFIG_USB_MDC800);
undef(&CONFIG_USB_SCANNER) if defined(&CONFIG_USB_SCANNER);
undef(&CONFIG_USB_MICROTEK) if defined(&CONFIG_USB_MICROTEK);
undef(&CONFIG_USB_HPUSBSCSI) if defined(&CONFIG_USB_HPUSBSCSI);
undef(&CONFIG_USB_PEGASUS) if defined(&CONFIG_USB_PEGASUS);
undef(&CONFIG_USB_RTL8150) if defined(&CONFIG_USB_RTL8150);
undef(&CONFIG_USB_KAWETH) if defined(&CONFIG_USB_KAWETH);
undef(&CONFIG_USB_CATC) if defined(&CONFIG_USB_CATC);
undef(&CONFIG_USB_AX8817X) if defined(&CONFIG_USB_AX8817X);
undef(&CONFIG_USB_CDCETHER) if defined(&CONFIG_USB_CDCETHER);
undef(&CONFIG_USB_USBNET) if defined(&CONFIG_USB_USBNET);
undef(&CONFIG_USB_USS720) if defined(&CONFIG_USB_USS720);
undef(&CONFIG_USB_SERIAL) if defined(&CONFIG_USB_SERIAL);
undef(&CONFIG_USB_RIO500) if defined(&CONFIG_USB_RIO500);
undef(&CONFIG_USB_AUERSWALD) if defined(&CONFIG_USB_AUERSWALD);
undef(&CONFIG_USB_TIGL) if defined(&CONFIG_USB_TIGL);
undef(&CONFIG_USB_BRLVGER) if defined(&CONFIG_USB_BRLVGER);
undef(&CONFIG_USB_LCD) if defined(&CONFIG_USB_LCD);
undef(&CONFIG_BLUEZ) if defined(&CONFIG_BLUEZ);
undef(&CONFIG_DEBUG_KERNEL) if defined(&CONFIG_DEBUG_KERNEL);
undef(&CONFIG_CRYPTO) if defined(&CONFIG_CRYPTO);
undef(&CONFIG_CRC32) if defined(&CONFIG_CRC32);
undef(&CONFIG_ZLIB_INFLATE) if defined(&CONFIG_ZLIB_INFLATE);
undef(&CONFIG_ZLIB_DEFLATE) if defined(&CONFIG_ZLIB_DEFLATE);
1;
