require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_BITS_SYSCALLS_H)) {
    eval 'sub _BITS_SYSCALLS_H () {1;}' unless defined(&_BITS_SYSCALLS_H);
    unless(defined(&_SYSCALL_H)) {
	die("Never use <bits/syscalls.h> directly; include <sys/syscall.h> instead.");
    }
    require 'bits/sysnum.ph';
    unless(defined(&__set_errno)) {
	eval 'sub __set_errno {
	    my($val) = @_;
    	    eval q((* &__errno_location ()) = ($val));
	}' unless defined(&__set_errno);
    }
    unless(defined(&__ASSEMBLER__)) {
	undef(&_syscall0) if defined(&_syscall0);
	eval 'sub _syscall0 {
	    my($type,$name) = @_;
    	    eval q($type $name( &void) {  &return ($type) ( &INLINE_SYSCALL($name, 0)); });
	}' unless defined(&_syscall0);
	undef(&_syscall1) if defined(&_syscall1);
	eval 'sub _syscall1 {
	    my($type,$name,$type1,$arg1) = @_;
    	    eval q($type $name($type1 $arg1) {  &return ($type) ( &INLINE_SYSCALL($name, 1, $arg1)); });
	}' unless defined(&_syscall1);
	undef(&_syscall2) if defined(&_syscall2);
	eval 'sub _syscall2 {
	    my($type,$name,$type1,$arg1,$type2,$arg2) = @_;
    	    eval q($type $name($type1 $arg1,$type2 $arg2) {  &return ($type) ( &INLINE_SYSCALL($name, 2, $arg1, $arg2)); });
	}' unless defined(&_syscall2);
	undef(&_syscall3) if defined(&_syscall3);
	eval 'sub _syscall3 {
	    my($type,$name,$type1,$arg1,$type2,$arg2,$type3,$arg3) = @_;
    	    eval q($type $name($type1 $arg1,$type2 $arg2,$type3 $arg3) {  &return ($type) ( &INLINE_SYSCALL($name, 3, $arg1, $arg2, $arg3)); });
	}' unless defined(&_syscall3);
	undef(&_syscall4) if defined(&_syscall4);
	eval 'sub _syscall4 {
	    my($type,$name,$type1,$arg1,$type2,$arg2,$type3,$arg3,$type4,$arg4) = @_;
    	    eval q($type $name ($type1 $arg1, $type2 $arg2, $type3 $arg3, $type4 $arg4) {  &return ($type) ( &INLINE_SYSCALL($name, 4, $arg1, $arg2, $arg3, $arg4)); });
	}' unless defined(&_syscall4);
	undef(&_syscall5) if defined(&_syscall5);
	eval 'sub _syscall5 {
	    my($type,$name,$type1,$arg1,$type2,$arg2,$type3,$arg3,$type4,$arg4, 	  $type5,$arg5) = @_;
    	    eval q($type $name ($type1 $arg1,$type2 $arg2,$type3 $arg3,$type4 $arg4,$type5 $arg5) {  &return ($type) ( &INLINE_SYSCALL($name, 5, $arg1, $arg2, $arg3, $arg4, $arg5)); });
	}' unless defined(&_syscall5);
	eval 'sub INLINE_SYSCALL () {( &name,  &nr,  &args...) ({ \'unsigned int resultvar\';  &asm  &volatile (  &LOADARGS_ &nr "movl %1, %%eax\\n\\t" "int $0x80\\n\\t"  &RESTOREARGS_ &nr : "=a" : "i" ( &__NR_ &name)  &ASMFMT_ &nr : "memory", "cc");  &if ( &resultvar >= 0xfffff001) {  &__set_errno (- &resultvar);  &resultvar = 0xffffffff; }  &resultvar; });}' unless defined(&INLINE_SYSCALL);
	eval 'sub LOADARGS_0 () {1;}' unless defined(&LOADARGS_0);
	eval 'sub LOADARGS_1 () {"bpushl .L__X\'%k2, %k2\\n\\t" "bmovl .L__X\'%k2, %k2\\n\\t";}' unless defined(&LOADARGS_1);
	eval 'sub LOADARGS_2 () { &LOADARGS_1;}' unless defined(&LOADARGS_2);
	eval 'sub LOADARGS_3 () { &LOADARGS_1;}' unless defined(&LOADARGS_3);
	eval 'sub LOADARGS_4 () { &LOADARGS_1;}' unless defined(&LOADARGS_4);
	eval 'sub LOADARGS_5 () { &LOADARGS_1;}' unless defined(&LOADARGS_5);
	eval 'sub RESTOREARGS_0 () {1;}' unless defined(&RESTOREARGS_0);
	eval 'sub RESTOREARGS_1 () {"bpopl .L__X\'%k2, %k2\\n\\t";}' unless defined(&RESTOREARGS_1);
	eval 'sub RESTOREARGS_2 () { &RESTOREARGS_1;}' unless defined(&RESTOREARGS_2);
	eval 'sub RESTOREARGS_3 () { &RESTOREARGS_1;}' unless defined(&RESTOREARGS_3);
	eval 'sub RESTOREARGS_4 () { &RESTOREARGS_1;}' unless defined(&RESTOREARGS_4);
	eval 'sub RESTOREARGS_5 () { &RESTOREARGS_1;}' unless defined(&RESTOREARGS_5);
	eval 'sub ASMFMT_0 () {
	    eval q();
	}' unless defined(&ASMFMT_0);
	eval 'sub ASMFMT_1 {
	    my($arg1) = @_;
    	    eval q(, \\"acdSD\\" ($arg1));
	}' unless defined(&ASMFMT_1);
	eval 'sub ASMFMT_2 {
	    my($arg1, $arg2) = @_;
    	    eval q(, \\"adCD\\" ($arg1), \\"c\\" ($arg2));
	}' unless defined(&ASMFMT_2);
	eval 'sub ASMFMT_3 {
	    my($arg1, $arg2, $arg3) = @_;
    	    eval q(, \\"aCD\\" ($arg1), \\"c\\" ($arg2), \\"d\\" ($arg3));
	}' unless defined(&ASMFMT_3);
	eval 'sub ASMFMT_4 {
	    my($arg1, $arg2, $arg3, $arg4) = @_;
    	    eval q(, \\"aD\\" ($arg1), \\"c\\" ($arg2), \\"d\\" ($arg3), \\"S\\" ($arg4));
	}' unless defined(&ASMFMT_4);
	eval 'sub ASMFMT_5 {
	    my($arg1, $arg2, $arg3, $arg4, $arg5) = @_;
    	    eval q(, \\"a\\" ($arg1), \\"c\\" ($arg2), \\"d\\" ($arg3), \\"S\\" ($arg4), \\"D\\" ($arg5));
	}' unless defined(&ASMFMT_5);
    }
}
1;
